#!python

import buttons, calc, functions, widgetGroups
import pygame
from pygame.locals import *

# Blah blah blah
print 'KavCalc 1.0e ( Oct 26, 2002 )'
print 'Written by Mogmios <mogmios@mlug.missouri.edu> with Python and Pygame.'

# Init
pygame.init ()
screen = pygame.display.set_mode ( ( 200, 170 ) )
pygame.display.set_caption ( 'KavCalc' )
pygame.mouse.set_visible ( 1 )

calc = calc.calc ()
clock = pygame.time.Clock ()
font = pygame.font.Font ( None, 30 )

# Create a widget group and fill it with buttons. Will pack itself.
buttonGroup = widgetGroups.widgetGroup ( pygame.Rect ( 10, 45, 190, 165 ), (
	# First row
	buttons.calcNumber ( calc, 'b0.png', '0', [ 256 ] ),
	buttons.calcNumber ( calc, 'b1.png', '1', [ 257 ] ),
	buttons.calcNumber ( calc, 'b2.png', '2', [ 258 ] ),
	buttons.calcNumber ( calc, 'b3.png', '3', [ 259 ] ),
	buttons.calcNumber ( calc, 'b4.png', '4', [ 260 ] ),
	buttons.calcReset ( calc, 'bclear.png', [ 'C', 'c' ], [] ),
	# Second row
	buttons.calcNumber ( calc, 'b5.png', '5', [ 261 ] ),
	buttons.calcNumber ( calc, 'b6.png', '6', [ 262 ] ),
	buttons.calcNumber ( calc, 'b7.png', '7', [ 263 ] ),
	buttons.calcNumber ( calc, 'b8.png', '8', [ 264 ] ),
	buttons.calcNumber ( calc, 'b9.png', '9', [ 265 ] ),
	buttons.calcOops ( calc, 'boops.png', [], [ 8, 127 ] ),
	# Third row
	buttons.calcNumber ( calc, 'bdot.png', '.', [ 266 ] ),
	buttons.calcFunction ( calc, 'badd.png', [ '+' ], [], 'add' ),
	buttons.calcFunction ( calc, 'bsub.png', [ '-' ], [], 'sub' ),
	buttons.calcFunction ( calc, 'bmul.png', [ '*' ], [], 'mul' ),
	buttons.calcFunction ( calc, 'bdiv.png', [ '/' ], [ 267 ], 'div' ),
	buttons.calcCompute ( calc, 'beq.png', [ '=' ], [ 13, 271 ] ),
	# Fourth row
	buttons.calcPercent ( calc, 'bperc.png', [ '%' ], [] ),
	buttons.calcSquare ( calc, 'bsqr.png', [ 'S', 's' ], [] ),
	buttons.calcSquareRoot ( calc, 'bsqrt.png', [ 'R', 'r' ], [] ),
	buttons.calcDivOne ( calc, 'bdiv1.png', [ 'D', 'd' ], [] ),
	buttons.calcPi ( calc, 'bpi.png', [ 'P', 'p' ], [] ),
	buttons.calcChangeSign ( calc, 'bpm.png', [], [ 9, 32 ] ) ) )

# Draw calculator
background, brect = functions.load_image ( 'background.png' )
display, drect = functions.load_image ( 'screen.png' )
background.blit ( display, ( 10, 10 ) )
screen.blit ( background, ( 0, 0 ) )
buttonGroup.draw ( screen )
pygame.display.update ()

# Main
def main ():
	while 1:
		clock.tick ( 60 )

		# Get user input. Quit if user tries to quit. Wait for
		# buttons clicked or hotkeys pressed.
		for event in pygame.event.get ():
			if event.type is QUIT:
				return
			elif event.type is KEYDOWN and event.key is K_ESCAPE:
				return
			elif event.type is MOUSEBUTTONDOWN:
				clicked = functions.buttons_clicked ( buttonGroup, pygame.mouse.get_pos () )
				for b in clicked:
					b.clicked ()
			elif event.type is KEYDOWN:
#				print event.key, event.mod, event.unicode
				keyed = functions.buttons_keyed ( buttonGroup, event.unicode, event.key )
				for b in keyed:
					b.clicked ()

		# Print calculator output to calculator screen.
		text = font.render ( calc.output (), 1, ( 255, 255, 255 ) )
		twidth = text.get_rect().width
		if twidth > 180:
			text = font.render ( 'Overflow', 1, ( 255, 0, 0 ) )
			twidth = text.get_rect().width

		# Redraw calculator
		buttonGroup.update ()
		screen.blit ( background, ( 0, 0 ) )
		screen.blit ( text, ( 190 - twidth, 10 ) )
		buttonGroup.draw ( screen )
		pygame.display.update ()


# Start
if __name__ == '__main__': main()
