#!python

import functions
import pygame
from pygame.locals import *

# Basic calculator button. Looks nice but does nothing.
class calcButton ( pygame.sprite.Sprite ):
	def __init__ ( self, calc, imagename, unis, keys ):
		pygame.sprite.Sprite.__init__ ( self )
		self.calc = calc
		self.image, self.rect = functions.load_image ( imagename, -1 )
		self.unis = unis
		self.keys = keys
		self.status = 0

	def is_key ( self, uni, key ):
		if ( uni in self.unis ) or ( key in self.keys ):
			return 1
		return 0

	def clicked ( self ):
		self.status = 2

	def update ( self ):
		if self.status == 2:
			self.status = 1
			self.rect = self.rect.inflate ( -4, -4 )
		elif self.status == 1:
			self.status = 0
			self.rect = self.rect.inflate ( 4, 4 )

# Calculator button for entering numbers.
class calcNumber ( calcButton ):
	def __init__ ( self, calc, imagename, digit, keys ):
		calcButton.__init__ ( self, calc, imagename, [ digit ], keys )
		self.digit = digit

	def clicked ( self ):
		calcButton.clicked ( self )
		self.calc.input ( self.digit )

# Calculator button for entering a function.
class calcFunction ( calcButton ):
	def __init__ ( self, calc, imagename, unis, keys, func ):
		calcButton.__init__ ( self, calc, imagename, unis, keys )
		self.func = func

	def clicked ( self ):
		calcButton.clicked ( self )
		self.calc.set_function ( self.func )

# Calculator button for computing the answer.
class calcCompute ( calcButton ):
	def __init__ ( self, calc, imagename, unis, keys ):
		calcButton.__init__ ( self, calc, imagename, unis, keys )

	def clicked ( self ):
		calcButton.clicked ( self )
		self.calc.compute ()

# Calculator button for erasing an input mistake.
class calcOops ( calcButton ):
	def __init__ ( self, calc, imagename, unis, keys ):
		calcButton.__init__ ( self, calc, imagename, unis, keys )

	def clicked ( self ):
		calcButton.clicked ( self )
		self.calc.oops ()

# Calculator button for reseting the calculator.
class calcReset ( calcButton ):
	def __init__ ( self, calc, imagename, unis, keys ):
		calcButton.__init__ ( self, calc, imagename, unis, keys )

	def clicked ( self ):
		calcButton.clicked ( self )
		self.calc.reset ()

# Calculator button for converting the input into a percent.
class calcPercent ( calcButton ):
	def __init__ ( self, calc, imagename, unis, keys ):
		calcButton.__init__ ( self, calc, imagename, unis, keys )

	def clicked ( self ):
		calcButton.clicked ( self )
		self.calc.percent ()

# Calculator button for squaring the input.
class calcSquare ( calcButton ):
	def __init__ ( self, calc, imagename, unis, keys ):
		calcButton.__init__ ( self, calc, imagename, unis, keys )

	def clicked ( self ):
		calcButton.clicked ( self )
		self.calc.square ()

# Calculator button for square rooting the input.
class calcSquareRoot ( calcButton ):
	def __init__ ( self, calc, imagename, unis, keys ):
		calcButton.__init__ ( self, calc, imagename, unis, keys )

	def clicked ( self ):
		calcButton.clicked ( self )
		self.calc.squareRoot ()

# Calculator button for dividing 1 by a number.
class calcDivOne ( calcButton ):
	def __init__ ( self, calc, imagename, unis, keys ):
		calcButton.__init__ ( self, calc, imagename, unis, keys )

	def clicked ( self ):
		calcButton.clicked ( self )
		self.calc.divOne ()

# Calculator button for inputing pi.
class calcPi ( calcButton ):
	def __init__ ( self, calc, imagename, unis, keys ):
		calcButton.__init__ ( self, calc, imagename, unis, keys )

	def clicked ( self ):
		calcButton.clicked ( self )
		self.calc.pi ()

# Calculator button for changing the sign of a number.
class calcChangeSign ( calcButton ):
	def __init__ ( self, calc, imagename, unis, keys ):
		calcButton.__init__ ( self, calc, imagename, unis, keys )

	def clicked ( self ):
		calcButton.clicked ( self )
		self.calc.changeSign ()
