#!python

import glob, os
import pygame
from pygame.locals import *

# Load an image from data directory.
def load_image ( name, colorkey = None ):
	expr = os.path.join ( 'data', name )
	try:
		fullname = glob.glob ( expr )[0]
	except:
		print 'Cannot find image:', name

	try:
		image = pygame.image.load ( fullname )
	except pygame.error, message:
		print 'Cannot load image:', name
		raise SystemExit, message

	image = image.convert ()

	if colorkey is not None:
		if colorkey is -1:
			colorkey = image.get_at ( ( 0,0 ) )

		image.set_colorkey ( colorkey, RLEACCEL )

	return image, image.get_rect ()

# Check for calculator buttons that've been clicked.
def buttons_clicked ( buttons, click ):
	collisions = []
	for s in buttons.sprites ():
		if s.rect.collidepoint ( click[0], click[1] ):
			collisions.append ( s )
	return collisions

# Check for calculator hotkeys that've been pressed.
def buttons_keyed ( buttons, uni, key ):
	keyed = []
	for s in buttons.sprites ():
		if s.is_key ( uni, key ):
			keyed.append ( s )
	return keyed
