#!python

import pygame
from pygame.locals import *

# A sprite group for drawing widgets. Is self packing.
class widgetGroup ( pygame.sprite.RenderPlain ):
	def __init__ ( self, rect, sprite=() ):
		self.x = rect.left
		self.y = self.newy = rect.top
		self.rect = rect
		pygame.sprite.RenderPlain.__init__ ( self, sprite )

	# Packs the widgets as they are added to the group.
	def add_internal ( self, sprite ):
		pygame.sprite.RenderPlain.add_internal ( self, sprite )

		if ( self.x + sprite.rect.width ) <= self.rect.right:
			sprite.rect.move_ip ( ( self.x, self.y ) )

			self.x += sprite.rect.width
			if ( self.y + sprite.rect.height ) > self.newy:
				self.newy = self.y + sprite.rect.height
		elif ( self.y + sprite.rect.height ) <= self.rect.bottom:
			self.x = self.rect.left
			self.y = self.newy
			sprite.rect.move_ip ( ( self.x, self.y ) )

			self.x += sprite.rect.width
			if ( self.y + sprite.rect.height ) > self.newy:
				self.newy = self.y + sprite.rect.height

	# Had to reimplement this because the default version doesn't
	# call it's own add_internal () method.
	def add ( self, sprite ):
		has = self.spritedict.has_key
		if hasattr ( sprite, '_spritegroup' ):
			for sprite in sprite.sprites ():
				if not has ( sprite ):
					self.add_internal ( sprite )
					sprite.add_internal ( self )
		else:
			try:
				len ( sprite ) #see if its a sequence
			except ( TypeError, AttributeError ):
				if not has ( sprite ):
					self.add_internal ( sprite )
					sprite.add_internal ( self )
			else:
				for sprite in sprite:
					if not has ( sprite ):
						self.add_internal ( sprite )
						sprite.add_internal ( self )
